// Check HairLine PathItems JavaScript for Adobe Illustrator CS3.
// Version 0.1 Copyleft (L) Jungle Software 2010.

// ======================================= Constants ======================================

const MODIFY_HIDDEN_LAYERS = true;
const MODIFY_LOCKED_LAYERS = true;

const MODIFY_HIDDEN_ITEMS = true;
const MODIFY_LOCKED_ITEMS = true;

const HAIRLINE_CHECK_WIDTH = 0.25;
const HAIRLINE_SET_WIDTH = 0.5;

// ======================================= Functions ======================================

function SetStrokeWidth(pathItem) {
	
	if(pathItem.hidden) {
		
		if(MODIFY_HIDDEN_ITEMS) {
							
			pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
			return 1;
		}
		else return 0;
	}
	else {

		if(pathItem.locked) {
			
			if(MODIFY_LOCKED_ITEMS) {
								
				pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
				return 1;
			}
			else return 0;
		}
		else {
			
			pathItem.strokeWidth = HAIRLINE_SET_WIDTH;
			return 1;
		}
	}
}

function main() {

	if(app.documents.length) {
		
		var lockedLayers = new Array();
		var visibleLayers = new Array();		
		
		var hairLinesCounter = 0;
		var modificationsCounter = 0;
		var pathItem;

		for(var i = 0; i < app.activeDocument.pathItems.length; i++) {
			
			if(!app.activeDocument.pathItems[i].guides) {
				
				pathItem = app.activeDocument.pathItems[i];

				try {

					if((pathItem.strokeWidth > 0)&&(pathItem.strokeWidth < HAIRLINE_CHECK_WIDTH)) {
						
						hairLinesCounter++;
						if(pathItem.hidden) {
															
							if(MODIFY_HIDDEN_ITEMS) {
							
								pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
								modificationsCounter++;
							}
							else ;
						}
						else {

							if(pathItem.locked) {
								
								if(MODIFY_LOCKED_ITEMS) {
								
									pathItem.strokeWidth = HAIRLINE_SET_WIDTH;								
									modificationsCounter++;
								}
								else ;
							}
							else {
								
								pathItem.strokeWidth = HAIRLINE_SET_WIDTH;
								modificationsCounter++;
							}
						}
					}
					else ;
				}
			
				catch(anyError) {
			
					if(pathItem.layer.locked) {
						
						if(MODIFY_LOCKED_LAYERS) {
				
							if(!pathItem.layer.visible) {
								
								if(MODIFY_HIDDEN_LAYERS) {
						
									pathItem.layer.locked = false;
									pathItem.layer.visible = true;
									lockedLayers.push(pathItem.layer);
									visibleLayers.push(pathItem.layer);							
									modificationsCounter += SetStrokeWidth(pathItem);
								}
								else ;
							}
							else {
						
								pathItem.layer.locked = false;
								lockedLayers.push(pathItem.layer);							
								modificationsCounter += SetStrokeWidth(pathItem);
							}
						}
						else ;
					}
					else {
				
						if(!pathItem.layer.visible) {
						
							if(MODIFY_HIDDEN_LAYERS) {
							
								pathItem.layer.visible = true;
								visibleLayers.push(pathItem.layer);
								modificationsCounter += SetStrokeWidth(pathItem);
							}
							else ;
						}
						else {
					
							alert("FUCK this Illustrator JavaScript Engine!\nCatch an unexpected error...");
							return;
						}
					}
				}
			}
			else ;
		}
		
		for(i = 0; i < visibleLayers.length; i++) visibleLayers[i].visible = false;
		for(i = 0; i < lockedLayers.length; i++) lockedLayers[i].locked = true;
		alert("Modified PathItems Number = " + modificationsCounter + "\nTotal HairLine PathItems Number = " + hairLinesCounter);			
	}
	else alert("Open document and try again...");
}		

main();